#!/usr/bin/env python

import os,sys,time,socket,threading,copy,StringIO,cPickle,subprocess,fcntl,struct,signal,shutil

class cGlobalData:
    pass


gd=cGlobalData()
gd.isTest = False

def main():
	global gd
	if( len(sys.argv) > 1 ):
		if(sys.argv[1] == "test"):
			gd.isTest = True

	gd.iBit=0
	sOut,sErr = fPopen("getconf LONG_BIT")
	if( int(sOut) == 32):
		gd.iBit=32
	else :
		gd.iBit=64

	initGD()

	print "start uninstalling safedog, please wait seconds ..."
	for sCmd in gd.arrCmds:
		#print sCmd
		sOut,sErr=fPopen(sCmd)
		if(len(sOut) > 0):
			print sOut
		if(len(sErr) > 0):
			print sErr
		

	print "safedog removed done!"

	return




def fPopen(aCmd):
	p=subprocess.Popen(aCmd, shell=True, bufsize=4096,stdin=subprocess.PIPE, stdout=subprocess.PIPE, stderr=subprocess.PIPE, close_fds=True)
	sOut = p.stdout.read()
	sErr = p.stderr.read()
	return (sOut,sErr)


def initGD():
	global gd

	gd.arrCmds=[]
	gd.arrCmds.append("killall sduibin >/dev/null 2>&1")
	gd.arrCmds.append("sdcmd exit >/dev/null 2>&1 &")
	gd.arrCmds.append("sleep 2")
	gd.arrCmds.append("killall sdsvrd >/dev/null 2>&1")
	if (gd.isTest ==  True):
		if(gd.iBit == 32):
			gd.arrCmds.append("uduninstall NF-7400L test")
		else:
			gd.arrCmds.append("uduninstall NF-7400L64 test")
		gd.arrCmds.append("rm -rf /etc/safedog")
		gd.arrCmds.append("rm -rf /usr/lib/safedog")
		gd.arrCmds.append("rm -rf /usr/lib/udcenter")
		gd.arrCmds.append("rm -rf /etc/sdsvrd.conf")
	else:
		if(gd.iBit == 32):
			gd.arrCmds.append("uduninstall NF-7400L")
		else:
			gd.arrCmds.append("uduninstall NF-7400L64")
	gd.arrCmds.append("rm -rf /etc/rc2.d/S99sdboot")
	gd.arrCmds.append("rm -rf /etc/rc3.d/S99sdboot")
	gd.arrCmds.append("rm -rf /etc/rc4.d/S99sdboot")
	gd.arrCmds.append("rm -rf /etc/rc5.d/S99sdboot")
	gd.arrCmds.append("rm -rf /etc/rc6.d/S99sdboot")
	gd.arrCmds.append("rm -rf /etc/init.d/safedog")
	gd.arrCmds.append("rm -rf /etc/init.d/sdboot")
	gd.arrCmds.append("rm -rf /usr/bin/safedog")
	gd.arrCmds.append("rm -rf /usr/bin/sdboot")
	gd.arrCmds.append("rm -rf /usr/bin/sdstart")
	gd.arrCmds.append("rm -rf /usr/bin/sdsvrd")
	gd.arrCmds.append("rm -rf /usr/bin/sdcmd")
	gd.arrCmds.append("rm -rf /usr/bin/sdtest")
	gd.arrCmds.append("rm -rf /usr/bin/sdui")
	gd.arrCmds.append("rm -rf /usr/bin/sduibin")
	gd.arrCmds.append("rm -rf /usr/bin/udinstall")
	gd.arrCmds.append("rm -rf /usr/bin/uduninstall")
	if (gd.isTest !=  True):
		gd.arrCmds.append("rm -rf /usr/lib/safedog/*")
		gd.arrCmds.append("date >> /etc/safedog/uninstall.log")


	return






if __name__ == "__main__":
    main()
    os._exit(0)

